diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
new file mode 100644
index ee3bfa8..d8488b7
*** a/src/bin/initdb/initdb.c
--- b/src/bin/initdb/initdb.c
*************** static bool debug = false;
*** 141,151 ****
--- 141,154 ----
  static bool noclean = false;
  static bool do_sync = true;
  static bool sync_only = false;
+ static bool pass_terminal_fd = false;
+ static char *term_fd_opt = NULL;
  static bool show_setting = false;
  static bool data_checksums = false;
  static char *xlog_dir = NULL;
  static char *str_wal_segment_size_mb = NULL;
  static int	wal_segment_size_mb;
+ static char *cluster_passphrase_cmd = NULL;
  
  
  /* internal vars */
*************** static const char *const subdirs[] = {
*** 203,208 ****
--- 206,212 ----
  	"global",
  	"pg_wal/archive_status",
  	"pg_commit_ts",
+ 	"pg_cryptokeys",
  	"pg_dynshmem",
  	"pg_notify",
  	"pg_serial",
*************** test_config_settings(void)
*** 954,965 ****
  		test_buffs = MIN_BUFS_FOR_CONNS(test_conns);
  
  		snprintf(cmd, sizeof(cmd),
! 				 "\"%s\" --boot -x0 %s "
  				 "-c max_connections=%d "
  				 "-c shared_buffers=%d "
  				 "-c dynamic_shared_memory_type=%s "
  				 "< \"%s\" > \"%s\" 2>&1",
  				 backend_exec, boot_options,
  				 test_conns, test_buffs,
  				 dynamic_shared_memory_type,
  				 DEVNULL, DEVNULL);
--- 958,970 ----
  		test_buffs = MIN_BUFS_FOR_CONNS(test_conns);
  
  		snprintf(cmd, sizeof(cmd),
! 				 "\"%s\" --boot -x0 %s %s "
  				 "-c max_connections=%d "
  				 "-c shared_buffers=%d "
  				 "-c dynamic_shared_memory_type=%s "
  				 "< \"%s\" > \"%s\" 2>&1",
  				 backend_exec, boot_options,
+ 				 term_fd_opt ? term_fd_opt : "",
  				 test_conns, test_buffs,
  				 dynamic_shared_memory_type,
  				 DEVNULL, DEVNULL);
*************** test_config_settings(void)
*** 990,1001 ****
  		}
  
  		snprintf(cmd, sizeof(cmd),
! 				 "\"%s\" --boot -x0 %s "
  				 "-c max_connections=%d "
  				 "-c shared_buffers=%d "
  				 "-c dynamic_shared_memory_type=%s "
  				 "< \"%s\" > \"%s\" 2>&1",
  				 backend_exec, boot_options,
  				 n_connections, test_buffs,
  				 dynamic_shared_memory_type,
  				 DEVNULL, DEVNULL);
--- 995,1007 ----
  		}
  
  		snprintf(cmd, sizeof(cmd),
! 				 "\"%s\" --boot -x0 %s %s "
  				 "-c max_connections=%d "
  				 "-c shared_buffers=%d "
  				 "-c dynamic_shared_memory_type=%s "
  				 "< \"%s\" > \"%s\" 2>&1",
  				 backend_exec, boot_options,
+ 				 term_fd_opt ? term_fd_opt : "",
  				 n_connections, test_buffs,
  				 dynamic_shared_memory_type,
  				 DEVNULL, DEVNULL);
*************** setup_config(void)
*** 1185,1190 ****
--- 1191,1203 ----
  								  "password_encryption = md5");
  	}
  
+ 	if (cluster_passphrase_cmd)
+ 	{
+ 		snprintf(repltok, sizeof(repltok), "cluster_passphrase_command = '%s'",
+ 				 escape_quotes(cluster_passphrase_cmd));
+ 		conflines = replace_token(conflines, "#cluster_passphrase_command = ''", repltok);
+ 	}
+ 
  	/*
  	 * If group access has been enabled for the cluster then it makes sense to
  	 * ensure that the log files also allow group access.  Otherwise a backup
*************** bootstrap_template1(void)
*** 1395,1407 ****
  	unsetenv("PGCLIENTENCODING");
  
  	snprintf(cmd, sizeof(cmd),
! 			 "\"%s\" --boot -x1 -X %u %s %s %s",
  			 backend_exec,
  			 wal_segment_size_mb * (1024 * 1024),
  			 data_checksums ? "-k" : "",
  			 boot_options,
! 			 debug ? "-d 5" : "");
! 
  
  	PG_CMD_OPEN;
  
--- 1408,1421 ----
  	unsetenv("PGCLIENTENCODING");
  
  	snprintf(cmd, sizeof(cmd),
! 			 "\"%s\" --boot -x1 -X %u %s %s %s %s %s",
  			 backend_exec,
  			 wal_segment_size_mb * (1024 * 1024),
  			 data_checksums ? "-k" : "",
+ 			 cluster_passphrase_cmd ? "-e" : "",
  			 boot_options,
! 			 debug ? "-d 5" : "",
! 			 term_fd_opt ? term_fd_opt : "");
  
  	PG_CMD_OPEN;
  
*************** usage(const char *progname)
*** 2290,2295 ****
--- 2304,2311 ----
  	printf(_("      --wal-segsize=SIZE    size of WAL segments, in megabytes\n"));
  	printf(_("\nLess commonly used options:\n"));
  	printf(_("  -d, --debug               generate lots of debugging output\n"));
+ 	printf(_("  -c  --cluster-passphrase-command=COMMAND\n"
+ 			 "                            set command to obtain passphrase for key management\n"));
  	printf(_("  -k, --data-checksums      use data page checksums\n"));
  	printf(_("  -L DIRECTORY              where to find the input files\n"));
  	printf(_("  -n, --no-clean            do not clean up after errors\n"));
*************** void
*** 2816,2822 ****
  initialize_data_directory(void)
  {
  	PG_CMD_DECL;
! 	int			i;
  
  	setup_signals();
  
--- 2832,2838 ----
  initialize_data_directory(void)
  {
  	PG_CMD_DECL;
! 	int			i, terminal_fd;
  
  	setup_signals();
  
*************** initialize_data_directory(void)
*** 2860,2865 ****
--- 2876,2897 ----
  	/* Top level PG_VERSION is checked by bootstrapper, so make it first */
  	write_version_file(NULL);
  
+ 	if (pass_terminal_fd)
+ 	{
+ #ifndef WIN32
+ 		terminal_fd = open("/dev/tty", O_RDWR, 0);
+ #else
+ 		terminal_fd = open("CONOUT$", O_RDWR, 0);
+ #endif
+ 		if (terminal_fd < 0)
+ 		{
+ 			pg_log_error(_("%s: could not open terminal: %s\n"),
+ 						 progname, strerror(errno));
+ 			exit(1);
+ 		}
+ 		term_fd_opt = psprintf(" -R %d", terminal_fd);
+ 	}
+ 
  	/* Select suitable configuration settings */
  	set_null_conf();
  	test_config_settings();
*************** initialize_data_directory(void)
*** 2883,2890 ****
  	fflush(stdout);
  
  	snprintf(cmd, sizeof(cmd),
! 			 "\"%s\" %s template1 >%s",
  			 backend_exec, backend_options,
  			 DEVNULL);
  
  	PG_CMD_OPEN;
--- 2915,2923 ----
  	fflush(stdout);
  
  	snprintf(cmd, sizeof(cmd),
! 			 "\"%s\" %s %s template1 >%s",
  			 backend_exec, backend_options,
+ 			 term_fd_opt ? term_fd_opt : "",
  			 DEVNULL);
  
  	PG_CMD_OPEN;
*************** main(int argc, char *argv[])
*** 2953,2963 ****
--- 2986,2998 ----
  		{"no-clean", no_argument, NULL, 'n'},
  		{"nosync", no_argument, NULL, 'N'}, /* for backwards compatibility */
  		{"no-sync", no_argument, NULL, 'N'},
+ 		{"read-terminal", no_argument, NULL, 'R'},
  		{"sync-only", no_argument, NULL, 'S'},
  		{"waldir", required_argument, NULL, 'X'},
  		{"wal-segsize", required_argument, NULL, 12},
  		{"data-checksums", no_argument, NULL, 'k'},
  		{"allow-group-access", no_argument, NULL, 'g'},
+ 		{"cluster-passphrase-command", required_argument, NULL, 'c'},
  		{NULL, 0, NULL, 0}
  	};
  
*************** main(int argc, char *argv[])
*** 2999,3005 ****
  
  	/* process command-line options */
  
! 	while ((c = getopt_long(argc, argv, "dD:E:kL:nNU:WA:sST:X:g", long_options, &option_index)) != -1)
  	{
  		switch (c)
  		{
--- 3034,3040 ----
  
  	/* process command-line options */
  
! 	while ((c = getopt_long(argc, argv, "A:c:dD:E:kL:nNRsST:U:WX:g", long_options, &option_index)) != -1)
  	{
  		switch (c)
  		{
*************** main(int argc, char *argv[])
*** 3045,3050 ****
--- 3080,3088 ----
  			case 'N':
  				do_sync = false;
  				break;
+ 			case 'R':
+ 				pass_terminal_fd = true;
+ 				break;
  			case 'S':
  				sync_only = true;
  				break;
*************** main(int argc, char *argv[])
*** 3081,3086 ****
--- 3119,3127 ----
  			case 9:
  				pwfilename = pg_strdup(optarg);
  				break;
+ 			case 'c':
+ 				cluster_passphrase_cmd = pg_strdup(optarg);
+ 				break;
  			case 's':
  				show_setting = true;
  				break;
*************** main(int argc, char *argv[])
*** 3151,3156 ****
--- 3192,3205 ----
  		exit(1);
  	}
  
+ #ifndef USE_OPENSSL
+ 	if (cluster_passphrase_cmd)
+ 	{
+ 		pg_log_error("cluster encryption is not supported because OpenSSL is not supported by this build");
+ 		exit(1);
+ 	}
+ #endif
+ 
  	check_authmethod_unspecified(&authmethodlocal);
  	check_authmethod_unspecified(&authmethodhost);
  
*************** main(int argc, char *argv[])
*** 3218,3223 ****
--- 3267,3277 ----
  	else
  		printf(_("Data page checksums are disabled.\n"));
  
+ 	if (cluster_passphrase_cmd)
+ 		printf(_("Key management system is enabled.\n"));
+ 	else
+ 		printf(_("Key management system is disabled.\n"));
+ 
  	if (pwprompt || pwfilename)
  		get_su_pwd();
  
diff --git a/src/bin/pg_controldata/pg_controldata.c b/src/bin/pg_controldata/pg_controldata.c
new file mode 100644
index 3e00ac0..39ba7f0
*** a/src/bin/pg_controldata/pg_controldata.c
--- b/src/bin/pg_controldata/pg_controldata.c
***************
*** 25,30 ****
--- 25,31 ----
  #include "access/xlog_internal.h"
  #include "catalog/pg_control.h"
  #include "common/controldata_utils.h"
+ #include "common/kmgr_utils.h"
  #include "common/logging.h"
  #include "getopt_long.h"
  #include "pg_getopt.h"
*************** main(int argc, char *argv[])
*** 334,338 ****
--- 335,341 ----
  		   ControlFile->data_checksum_version);
  	printf(_("Mock authentication nonce:            %s\n"),
  		   mock_auth_nonce_str);
+ 	printf(_("Key management version:               %u\n"),
+ 		   ControlFile->key_management_version);
  	return 0;
  }
diff --git a/src/bin/pg_ctl/pg_ctl.c b/src/bin/pg_ctl/pg_ctl.c
new file mode 100644
index fc07f1a..a7a4e68
*** a/src/bin/pg_ctl/pg_ctl.c
--- b/src/bin/pg_ctl/pg_ctl.c
*************** typedef enum
*** 79,84 ****
--- 79,85 ----
  static bool do_wait = true;
  static int	wait_seconds = DEFAULT_WAIT;
  static bool wait_seconds_arg = false;
+ static bool pass_terminal_fd = false;
  static bool silent_mode = false;
  static ShutdownMode shutdown_mode = FAST_MODE;
  static int	sig = SIGINT;		/* default */
*************** free_readfile(char **optlines)
*** 442,448 ****
  static pgpid_t
  start_postmaster(void)
  {
! 	char		cmd[MAXPGPATH];
  
  #ifndef WIN32
  	pgpid_t		pm_pid;
--- 443,450 ----
  static pgpid_t
  start_postmaster(void)
  {
! 	char		cmd[MAXPGPATH], *term_fd_opt = NULL;
! 	int			terminal_fd;
  
  #ifndef WIN32
  	pgpid_t		pm_pid;
*************** start_postmaster(void)
*** 467,472 ****
--- 469,486 ----
  
  	/* fork succeeded, in child */
  
+ 	if (pass_terminal_fd)
+ 	{
+ 		terminal_fd = open("/dev/tty", O_RDWR, 0);
+ 		if (terminal_fd < 0)
+ 		{
+ 			write_stderr(_("%s: could not open terminal: %s\n"),
+ 						 progname, strerror(errno));
+ 			exit(1);
+ 		}
+ 		term_fd_opt = psprintf(" -R %d", terminal_fd);
+ 	}
+ 
  	/*
  	 * If possible, detach the postmaster process from the launching process
  	 * group and make it a group leader, so that it doesn't get signaled along
*************** start_postmaster(void)
*** 487,498 ****
  	 * has the same PID as the current child process.
  	 */
  	if (log_file != NULL)
! 		snprintf(cmd, MAXPGPATH, "exec \"%s\" %s%s < \"%s\" >> \"%s\" 2>&1",
  				 exec_path, pgdata_opt, post_opts,
  				 DEVNULL, log_file);
  	else
! 		snprintf(cmd, MAXPGPATH, "exec \"%s\" %s%s < \"%s\" 2>&1",
! 				 exec_path, pgdata_opt, post_opts, DEVNULL);
  
  	(void) execl("/bin/sh", "/bin/sh", "-c", cmd, (char *) NULL);
  
--- 501,514 ----
  	 * has the same PID as the current child process.
  	 */
  	if (log_file != NULL)
! 		snprintf(cmd, MAXPGPATH, "exec \"%s\" %s%s%s < \"%s\" >> \"%s\" 2>&1",
  				 exec_path, pgdata_opt, post_opts,
+ 				 term_fd_opt ? term_fd_opt : "",
  				 DEVNULL, log_file);
  	else
! 		snprintf(cmd, MAXPGPATH, "exec \"%s\" %s%s%s < \"%s\" 2>&1",
! 				 exec_path, pgdata_opt, post_opts,
! 				 term_fd_opt ? term_fd_opt : "", DEVNULL);
  
  	(void) execl("/bin/sh", "/bin/sh", "-c", cmd, (char *) NULL);
  
*************** start_postmaster(void)
*** 513,518 ****
--- 529,548 ----
  	PROCESS_INFORMATION pi;
  	const char *comspec;
  
+ 	if (pass_terminal_fd)
+ 	{
+ 		/*  Hopefully we can read and write CONOUT, see simple_prompt() */
+ 		/*  Do CreateRestrictedProcess() children even inherit open file descriptors? */
+ 		terminal_fd = open("CONOUT$", O_RDWR, 0);
+ 		if (terminal_fd < 0)
+ 		{
+ 			write_stderr(_("%s: could not open terminal: %s\n"),
+ 						 progname, strerror(errno));
+ 			exit(1);
+ 		}
+ 		term_fd_opt = psprintf(" -R %d", terminal_fd);
+ 	}
+ 
  	/* Find CMD.EXE location using COMSPEC, if it's set */
  	comspec = getenv("COMSPEC");
  	if (comspec == NULL)
*************** start_postmaster(void)
*** 553,564 ****
  		else
  			close(fd);
  
! 		snprintf(cmd, MAXPGPATH, "\"%s\" /C \"\"%s\" %s%s < \"%s\" >> \"%s\" 2>&1\"",
! 				 comspec, exec_path, pgdata_opt, post_opts, DEVNULL, log_file);
  	}
  	else
! 		snprintf(cmd, MAXPGPATH, "\"%s\" /C \"\"%s\" %s%s < \"%s\" 2>&1\"",
! 				 comspec, exec_path, pgdata_opt, post_opts, DEVNULL);
  
  	if (!CreateRestrictedProcess(cmd, &pi, false))
  	{
--- 583,596 ----
  		else
  			close(fd);
  
! 		snprintf(cmd, MAXPGPATH, "\"%s\" /C \"\"%s\" %s%s%s < \"%s\" >> \"%s\" 2>&1\"",
! 				 comspec, exec_path, pgdata_opt, post_opts,
! 				 term_fd_opt ? term_fd_opt : "", DEVNULL, log_file);
  	}
  	else
! 		snprintf(cmd, MAXPGPATH, "\"%s\" /C \"\"%s\" %s%s%s < \"%s\" 2>&1\"",
! 				 comspec, exec_path, pgdata_opt, post_opts,
! 				 term_fd_opt ? term_fd_opt : "", DEVNULL);
  
  	if (!CreateRestrictedProcess(cmd, &pi, false))
  	{
*************** wait_for_postmaster(pgpid_t pm_pid, bool
*** 689,695 ****
  			}
  			else
  #endif
! 				print_msg(".");
  		}
  
  		pg_usleep(USEC_PER_SEC / WAITS_PER_SEC);
--- 721,728 ----
  			}
  			else
  #endif
! 				if (!pass_terminal_fd)
! 					print_msg(".");
  		}
  
  		pg_usleep(USEC_PER_SEC / WAITS_PER_SEC);
*************** main(int argc, char **argv)
*** 2260,2265 ****
--- 2293,2299 ----
  		{"mode", required_argument, NULL, 'm'},
  		{"pgdata", required_argument, NULL, 'D'},
  		{"options", required_argument, NULL, 'o'},
+ 		{"read-terminal", no_argument, NULL, 'R'},
  		{"silent", no_argument, NULL, 's'},
  		{"timeout", required_argument, NULL, 't'},
  		{"core-files", no_argument, NULL, 'c'},
*************** main(int argc, char **argv)
*** 2332,2338 ****
  	/* process command-line options */
  	while (optind < argc)
  	{
! 		while ((c = getopt_long(argc, argv, "cD:e:l:m:N:o:p:P:sS:t:U:wW",
  								long_options, &option_index)) != -1)
  		{
  			switch (c)
--- 2366,2372 ----
  	/* process command-line options */
  	while (optind < argc)
  	{
! 		while ((c = getopt_long(argc, argv, "cD:e:l:m:N:o:p:P:RsS:t:U:wW",
  								long_options, &option_index)) != -1)
  		{
  			switch (c)
*************** main(int argc, char **argv)
*** 2385,2390 ****
--- 2419,2427 ----
  				case 'P':
  					register_password = pg_strdup(optarg);
  					break;
+ 				case 'R':
+ 					pass_terminal_fd = true;
+ 					break;
  				case 's':
  					silent_mode = true;
  					break;
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
new file mode 100644
index cb6ef19..a9d200e
*** a/src/bin/pg_resetwal/pg_resetwal.c
--- b/src/bin/pg_resetwal/pg_resetwal.c
*************** PrintControlValues(bool guessed)
*** 804,809 ****
--- 804,811 ----
  		   (ControlFile.float8ByVal ? _("by value") : _("by reference")));
  	printf(_("Data page checksum version:           %u\n"),
  		   ControlFile.data_checksum_version);
+ 	printf(_("Key management version:               %u\n"),
+ 		   ControlFile.key_management_version);
  }
  
  
diff --git a/src/bin/pg_rewind/filemap.c b/src/bin/pg_rewind/filemap.c
new file mode 100644
index 1abc257..3084ae7
*** a/src/bin/pg_rewind/filemap.c
--- b/src/bin/pg_rewind/filemap.c
*************** static const char *excludeDirContents[]
*** 74,79 ****
--- 74,87 ----
  	"pg_notify",
  
  	/*
+ 	 * Skip cryptographic keys. It's generally not good idea to copy the
+ 	 * cryptographic keys from source database because these might use
+ 	 * different cluster passphrase.
+ 	 */
+ 	"pg_cryptokeys",			/* defined as KMGR_DIR */
+ 	"pg_cryptokeys_tmp",		/* defined as KMGR_TMP_DIR */
+ 
+ 	/*
  	 * Old contents are loaded for possible debugging but are not required for
  	 * normal operation, see SerialInit().
  	 */
diff --git a/src/bin/pg_upgrade/controldata.c b/src/bin/pg_upgrade/controldata.c
new file mode 100644
index 39bcaa8..e5794ff
*** a/src/bin/pg_upgrade/controldata.c
--- b/src/bin/pg_upgrade/controldata.c
***************
*** 9,18 ****
--- 9,24 ----
  
  #include "postgres_fe.h"
  
+ #include <dirent.h>
  #include <ctype.h>
  
  #include "pg_upgrade.h"
  
+ #include "access/xlog_internal.h"
+ #include "common/controldata_utils.h"
+ #include "common/file_utils.h"
+ #include "common/kmgr_utils.h"
+ 
  /*
   * get_control_data()
   *
*************** get_control_data(ClusterInfo *cluster, b
*** 59,64 ****
--- 65,71 ----
  	bool		got_date_is_int = false;
  	bool		got_data_checksum_version = false;
  	bool		got_cluster_state = false;
+ 	bool		got_key_management_enabled = false;
  	char	   *lc_collate = NULL;
  	char	   *lc_ctype = NULL;
  	char	   *lc_monetary = NULL;
*************** get_control_data(ClusterInfo *cluster, b
*** 202,207 ****
--- 209,221 ----
  		got_data_checksum_version = true;
  	}
  
+ 	/* Only in <= 14 */
+ 	if (GET_MAJOR_VERSION(cluster->major_version) <= 1400)
+ 	{
+ 		cluster->controldata.key_management_enabled = false;
+ 		got_key_management_enabled = true;
+ 	}
+ 
  	/* we have the result of cmd in "output". so parse it line by line now */
  	while (fgets(bufin, sizeof(bufin), output))
  	{
*************** get_control_data(ClusterInfo *cluster, b
*** 485,490 ****
--- 499,516 ----
  			cluster->controldata.data_checksum_version = str2uint(p);
  			got_data_checksum_version = true;
  		}
+ 		else if ((p = strstr(bufin, "Key management:")) != NULL)
+ 		{
+ 			p = strchr(p, ':');
+ 
+ 			if (p == NULL || strlen(p) <= 1)
+ 				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
+ 
+ 			p++;				/* remove ':' char */
+ 			/* used later for contrib check */
+ 			cluster->controldata.key_management_enabled = strstr(p, "on") != NULL;
+ 			got_key_management_enabled = true;
+ 		}
  	}
  
  	pclose(output);
*************** get_control_data(ClusterInfo *cluster, b
*** 539,545 ****
  		!got_index || !got_toast ||
  		(!got_large_object &&
  		 cluster->controldata.ctrl_ver >= LARGE_OBJECT_SIZE_PG_CONTROL_VER) ||
! 		!got_date_is_int || !got_data_checksum_version)
  	{
  		if (cluster == &old_cluster)
  			pg_log(PG_REPORT,
--- 565,572 ----
  		!got_index || !got_toast ||
  		(!got_large_object &&
  		 cluster->controldata.ctrl_ver >= LARGE_OBJECT_SIZE_PG_CONTROL_VER) ||
! 		!got_date_is_int || !got_data_checksum_version ||
! 		!got_key_management_enabled)
  	{
  		if (cluster == &old_cluster)
  			pg_log(PG_REPORT,
*************** get_control_data(ClusterInfo *cluster, b
*** 605,610 ****
--- 632,641 ----
  		if (!got_data_checksum_version)
  			pg_log(PG_REPORT, "  data checksum version\n");
  
+ 		/* value added in Postgres 12 */
+ 		if (!got_key_management_enabled)
+ 			pg_log(PG_REPORT, "  key management enabled\n");
+ 
  		pg_fatal("Cannot continue without required control information, terminating\n");
  	}
  }
*************** check_control_data(ControlData *oldctrl,
*** 669,674 ****
--- 700,713 ----
  		pg_fatal("old cluster uses data checksums but the new one does not\n");
  	else if (oldctrl->data_checksum_version != newctrl->data_checksum_version)
  		pg_fatal("old and new cluster pg_controldata checksum versions do not match\n");
+ 
+ 	/*
+ 	 * We cannot upgrade if the old cluster enables the key management but
+ 	 * the new one doesn't support because the old one might already have
+ 	 * data encrypted by the master encryption key.
+ 	 */
+ 	if (oldctrl->key_management_enabled && !newctrl->key_management_enabled)
+ 		pg_fatal("old cluster uses key management but the new one does not\n");
  }
  
  
diff --git a/src/bin/pg_upgrade/file.c b/src/bin/pg_upgrade/file.c
new file mode 100644
index cc8a675..282359f
*** a/src/bin/pg_upgrade/file.c
--- b/src/bin/pg_upgrade/file.c
***************
*** 11,16 ****
--- 11,17 ----
  
  #include <sys/stat.h>
  #include <fcntl.h>
+ #include <dirent.h>
  #ifdef HAVE_COPYFILE_H
  #include <copyfile.h>
  #endif
***************
*** 21,26 ****
--- 22,28 ----
  
  #include "access/visibilitymap.h"
  #include "common/file_perm.h"
+ #include "common/file_utils.h"
  #include "pg_upgrade.h"
  #include "storage/bufpage.h"
  #include "storage/checksum.h"
*************** check_hard_link(void)
*** 372,374 ****
--- 374,451 ----
  
  	unlink(new_link_file);
  }
+ 
+ /*
+  * Copy cryptographic keys from the old cluster to the new cluster.
+  */
+ void
+ copy_master_encryption_key(ClusterInfo *old_cluster, ClusterInfo * new_cluster)
+ {
+ 	DIR				*dir;
+ 	struct dirent *de;
+ 	char path[MAXPGPATH];
+ 
+ 	/* We copy the crypto keys only if both clusters enable the key management */
+ 	if (!old_cluster->controldata.key_management_enabled ||
+ 		!new_cluster->controldata.key_management_enabled)
+ 		return;
+ 
+ 	prep_status("Copying master encryption key");
+ 
+ 	snprintf(path, MAXPGPATH, "%s/%s", old_cluster->pgdata, KMGR_DIR);
+ 
+ 	if ((dir = opendir(path)) == NULL)
+ 		pg_fatal("could not open directory \"%s\": %m", path);
+ 
+ 	while ((de = readdir(dir)) != NULL)
+ 	{
+ 		if (strlen(de->d_name) == 4 &&
+ 			strspn(de->d_name, "0123456789ABCDEF") == 4)
+ 		{
+ 			CryptoKey key;
+ 			char src_path[MAXPGPATH];
+ 			char dst_path[MAXPGPATH];
+ 			uint32	id;
+ 			int src_fd;
+ 			int dst_fd;
+ 			int len;
+ 
+ 			id = strtoul(de->d_name, NULL, 16);
+ 
+ 			snprintf(src_path, MAXPGPATH, "%s/%s/%04X",
+ 					 old_cluster->pgdata, KMGR_DIR, id);
+ 			snprintf(dst_path, MAXPGPATH, "%s/%s/%04X",
+ 					 new_cluster->pgdata, KMGR_DIR, id);
+ 
+ 			if ((src_fd = open(src_path, O_RDONLY | PG_BINARY, 0)) < 0)
+ 				pg_fatal("could not open file \"%s\": %m", src_path);
+ 
+ 			if ((dst_fd = open(dst_path, O_RDWR | O_CREAT | O_TRUNC | PG_BINARY,
+ 								pg_file_create_mode)) < 0)
+ 				pg_fatal("could not open file \"%s\": %m", dst_path);
+ 
+ 			/* Read the source key */
+ 			len = read(src_fd, &key, sizeof(CryptoKey));
+ 			if (len != sizeof(CryptoKey))
+ 			{
+ 				if (len < 0)
+ 					pg_fatal("could not read file \"%s\": %m", src_path);
+ 				else
+ 					pg_fatal("could not read file \"%s\": read %d of %zu",
+ 							 src_path, len, sizeof(CryptoKey));
+ 			}
+ 
+ 			/* Write to the dest key */
+ 			len = write(dst_fd, &key, sizeof(CryptoKey));
+ 			if (len != sizeof(CryptoKey))
+ 				pg_fatal("could not write fie \"%s\"", dst_path);
+ 
+ 			close(src_fd);
+ 			close(dst_fd);
+ 		}
+ 	}
+ 
+ 	closedir(dir);
+ 
+ 	check_ok();
+ }
diff --git a/src/bin/pg_upgrade/pg_upgrade.c b/src/bin/pg_upgrade/pg_upgrade.c
new file mode 100644
index 1bc86e4..d1bacdf
*** a/src/bin/pg_upgrade/pg_upgrade.c
--- b/src/bin/pg_upgrade/pg_upgrade.c
*************** main(int argc, char **argv)
*** 158,163 ****
--- 158,170 ----
  								 old_cluster.pgdata, new_cluster.pgdata);
  
  	/*
+ 	 * Copy the internal encryption keys from the old cluster to the new one.
+ 	 * This is necessary because the data in the old cluster might be
+ 	 * encrypted with the old master encryption key.
+ 	 */
+ 	copy_master_encryption_key(&old_cluster, &new_cluster);
+ 
+ 	/*
  	 * Assuming OIDs are only used in system tables, there is no need to
  	 * restore the OID counter because we have not transferred any OIDs from
  	 * the old system, but we do it anyway just in case.  We do it late here
diff --git a/src/bin/pg_upgrade/pg_upgrade.h b/src/bin/pg_upgrade/pg_upgrade.h
new file mode 100644
index 8b90cef..32ab236
*** a/src/bin/pg_upgrade/pg_upgrade.h
--- b/src/bin/pg_upgrade/pg_upgrade.h
***************
*** 11,16 ****
--- 11,17 ----
  #include <sys/time.h>
  
  #include "libpq-fe.h"
+ #include "common/kmgr_utils.h"
  
  /* Use port in the private/dynamic port number range */
  #define DEF_PGUPORT			50432
*************** typedef struct
*** 219,224 ****
--- 220,226 ----
  	bool		date_is_int;
  	bool		float8_pass_by_value;
  	bool		data_checksum_version;
+ 	bool		key_management_enabled;
  } ControlData;
  
  /*
*************** void		rewriteVisibilityMap(const char *f
*** 375,380 ****
--- 377,384 ----
  								 const char *schemaName, const char *relName);
  void		check_file_clone(void);
  void		check_hard_link(void);
+ void		copy_master_encryption_key(ClusterInfo *old_cluster,
+ 									   ClusterInfo * new_cluster);
  
  /* fopen_priv() is no longer different from fopen() */
  #define fopen_priv(path, mode)	fopen(path, mode)
diff --git a/src/common/Makefile b/src/common/Makefile
new file mode 100644
index 25c55bd..cfb34fd
*** a/src/common/Makefile
--- b/src/common/Makefile
*************** OBJS_COMMON = \
*** 49,54 ****
--- 49,55 ----
  	archive.o \
  	base64.o \
  	checksum_helper.o \
+ 	cipher.o \
  	config_info.o \
  	controldata_utils.o \
  	d2s.o \
*************** OBJS_COMMON = \
*** 61,66 ****
--- 62,68 ----
  	ip.o \
  	jsonapi.o \
  	keywords.o \
+ 	kmgr_utils.o \
  	kwlookup.o \
  	link-canary.o \
  	md5.o \
*************** OBJS_COMMON = \
*** 81,86 ****
--- 83,89 ----
  
  ifeq ($(with_openssl),yes)
  OBJS_COMMON += \
+ 	cipher_openssl.o \
  	protocol_openssl.o \
  	sha2_openssl.o
  else
diff --git a/src/common/cipher.c b/src/common/cipher.c
new file mode 100644
index ...908afe8
*** a/src/common/cipher.c
--- b/src/common/cipher.c
***************
*** 0 ****
--- 1,87 ----
+ /*-------------------------------------------------------------------------
+  *
+  * cipher.c
+  *	  Shared frontend/backend for cryptographic functions
+  *
+  * Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * IDENTIFICATION
+  *	  src/common/cipher.c
+  *
+  *-------------------------------------------------------------------------
+  */
+ 
+ #ifndef FRONTEND
+ #include "postgres.h"
+ #else
+ #include "postgres_fe.h"
+ #endif
+ 
+ #include "common/cipher.h"
+ #ifdef USE_OPENSSL
+ #include "common/cipher_openssl.h"
+ #endif
+ 
+ /*
+  * Return a newly created cipher context.  'cipher' specifies cipher algorithm
+  * by identifer like PG_CIPHER_XXX.
+  */
+ PgCipherCtx *
+ pg_cipher_ctx_create(int cipher, uint8 *key, int klen)
+ {
+ 	PgCipherCtx *ctx = NULL;
+ 
+ 	if (cipher >= PG_MAX_CIPHER_ID)
+ 		return NULL;
+ 
+ #ifdef USE_OPENSSL
+ 	ctx = (PgCipherCtx *) palloc0(sizeof(PgCipherCtx));
+ 
+ 	ctx->encctx = ossl_cipher_ctx_create(cipher, key, klen, true);
+ 	ctx->decctx = ossl_cipher_ctx_create(cipher, key, klen, false);
+ #endif
+ 
+ 	return ctx;
+ }
+ 
+ void
+ pg_cipher_ctx_free(PgCipherCtx *ctx)
+ {
+ #ifdef USE_OPENSSL
+ 	ossl_cipher_ctx_free(ctx->encctx);
+ 	ossl_cipher_ctx_free(ctx->decctx);
+ #endif
+ }
+ 
+ bool
+ pg_cipher_encrypt(PgCipherCtx *ctx, const uint8 *in, int inlen,
+ 				  uint8 *out, int *outlen, const uint8 *iv)
+ {
+ 	bool		r = false;
+ #ifdef USE_OPENSSL
+ 	r = ossl_cipher_encrypt(ctx->encctx, in, inlen, out, outlen, iv);
+ #endif
+ 	return r;
+ }
+ 
+ bool
+ pg_cipher_decrypt(PgCipherCtx *ctx, const uint8 *in, int inlen,
+ 				  uint8 *out, int *outlen, const uint8 *iv)
+ {
+ 	bool		r = false;
+ #ifdef USE_OPENSSL
+ 	r = ossl_cipher_decrypt(ctx->decctx, in, inlen, out, outlen, iv);
+ #endif
+ 	return r;
+ }
+ 
+ bool
+ pg_HMAC_SHA512(const uint8 *key, const uint8 *in, int inlen,
+ 			   uint8 *out)
+ {
+ 	bool		r = false;
+ #ifdef USE_OPENSSL
+ 	r = ossl_HMAC_SHA512(key, in, inlen, out);
+ #endif
+ 	return r;
+ }
diff --git a/src/common/cipher_openssl.c b/src/common/cipher_openssl.c
new file mode 100644
index ...e8bc241
*** a/src/common/cipher_openssl.c
--- b/src/common/cipher_openssl.c
***************
*** 0 ****
--- 1,181 ----
+ /*-------------------------------------------------------------------------
+  * cipher_openssl.c
+  *		Cryptographic function using OpenSSL
+  *
+  * This contains the common low-level functions needed in both frontend and
+  * backend, for implement the database encryption.
+  *
+  * Portions Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * IDENTIFICATION
+  *	  src/common/cipher_openssl.c
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef FRONTEND
+ #include "postgres.h"
+ #else
+ #include "postgres_fe.h"
+ #endif
+ 
+ #include "common/sha2.h"
+ #include "common/cipher_openssl.h"
+ 
+ #include <openssl/ssl.h>
+ #include <openssl/conf.h>
+ #include <openssl/evp.h>
+ #include <openssl/err.h>
+ #include <openssl/hmac.h>
+ 
+ /*
+  * prototype for the EVP functions that return an algorithm, e.g.
+  * EVP_aes_128_cbc().
+  */
+ typedef const EVP_CIPHER *(*ossl_EVP_cipher_func) (void);
+ 
+ static bool ossl_initialized = false;
+ 
+ static ossl_EVP_cipher_func get_evp_aes_cbc(int klen);
+ 
+ static ossl_EVP_cipher_func
+ get_evp_aes_cbc(int klen)
+ {
+ 	switch (klen)
+ 	{
+ 		case PG_AES128_KEY_LEN:
+ 			return EVP_aes_128_cbc;
+ 		case PG_AES192_KEY_LEN:
+ 			return EVP_aes_192_cbc;
+ 		case PG_AES256_KEY_LEN:
+ 			return EVP_aes_256_cbc;
+ 		default:
+ 			return NULL;
+ 	}
+ }
+ 
+ /*
+  * Initialize and return an EVP_CIPHER_CTX. Return NULL if the given
+  * cipher algorithm is not supported or on failure..
+  */
+ EVP_CIPHER_CTX *
+ ossl_cipher_ctx_create(int cipher, uint8 *key, int klen, bool enc)
+ {
+ 	EVP_CIPHER_CTX			*ctx;
+ 	ossl_EVP_cipher_func	func;
+ 	int	ret;
+ 
+ 	if (!ossl_initialized)
+ 	{
+ #ifdef HAVE_OPENSSL_INIT_SSL
+ 		OPENSSL_init_ssl(OPENSSL_INIT_LOAD_CONFIG, NULL);
+ #else
+ 		OPENSSL_config(NULL);
+ 		SSL_library_init();
+ 		SSL_load_error_strings();
+ #endif
+ 		ossl_initialized = true;
+ 	}
+ 
+ 	ctx = EVP_CIPHER_CTX_new();
+ 
+ 	switch (cipher)
+ 	{
+ 		case PG_CIPHER_AES_CBC:
+ 			func = get_evp_aes_cbc(klen);
+ 			if (!func)
+ 				goto failed;
+ 			break;
+ 		default:
+ 			goto failed;
+ 	}
+ 
+ 
+ 	if (enc)
+ 		ret = EVP_EncryptInit_ex(ctx, (const EVP_CIPHER *) func(), NULL, key, NULL);
+ 	else
+ 		ret = EVP_DecryptInit_ex(ctx, (const EVP_CIPHER *) func(), NULL, key, NULL);
+ 
+ 	if (!ret)
+ 		goto failed;
+ 
+ 	if (!EVP_CIPHER_CTX_set_key_length(ctx, PG_AES256_KEY_LEN))
+ 		goto failed;
+ 
+ 	/*
+ 	 * Always enable padding. We don't need to check the return value as
+ 	 * EVP_CIPHER_CTX_set_padding always returns 1.
+ 	 */
+ 	EVP_CIPHER_CTX_set_padding(ctx, 1);
+ 
+ 	return ctx;
+ 
+ failed:
+ 	EVP_CIPHER_CTX_free(ctx);
+ 	return NULL;
+ }
+ 
+ void
+ ossl_cipher_ctx_free(EVP_CIPHER_CTX *ctx)
+ {
+ 	return EVP_CIPHER_CTX_free(ctx);
+ }
+ 
+ bool
+ ossl_cipher_encrypt(EVP_CIPHER_CTX *ctx,
+ 					const uint8 *in, int inlen,
+ 					uint8 *out, int *outlen,
+ 					const uint8 *iv)
+ {
+ 	int			len;
+ 	int			enclen;
+ 
+ 	if (!EVP_EncryptInit_ex(ctx, NULL, NULL, NULL, iv))
+ 		return false;
+ 
+ 	if (!EVP_EncryptUpdate(ctx, out, &len, in, inlen))
+ 		return false;
+ 
+ 	enclen = len;
+ 
+ 	if (!EVP_EncryptFinal_ex(ctx, (uint8 *) ((char *) out + enclen),
+ 							 &len))
+ 		return false;
+ 
+ 	*outlen = enclen + len;
+ 
+ 	return true;
+ }
+ 
+ bool
+ ossl_cipher_decrypt(EVP_CIPHER_CTX *ctx,
+ 					const uint8 *in, int inlen,
+ 					uint8 *out, int *outlen,
+ 					const uint8 *iv)
+ {
+ 	int			declen;
+ 	int			len;
+ 
+ 	if (!EVP_DecryptInit_ex(ctx, NULL, NULL, NULL, iv))
+ 		return false;
+ 
+ 	if (!EVP_DecryptUpdate(ctx, out, &len, in, inlen))
+ 		return false;
+ 
+ 	declen = len;
+ 
+ 	if (!EVP_DecryptFinal_ex(ctx, (uint8 *) ((char *) out + declen),
+ 							 &len))
+ 		return false;
+ 
+ 	*outlen = declen + len;
+ 
+ 	return true;
+ }
+ 
+ bool
+ ossl_HMAC_SHA512(const uint8 *key, const uint8 *in, int inlen,
+ 				 uint8 *out)
+ {
+ 	return HMAC(EVP_sha512(), key, PG_SHA512_DIGEST_LENGTH,
+ 				in, (uint32) inlen, out, NULL);
+ }
